const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const data_entities = sequelize.define(
    'data_entities',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.ENUM,
      
      

        values: [

"products",


"customers",


"suppliers",


"availability"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_enabled: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  data_entities.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










    db.data_entities.hasMany(db.import_jobs, {
      as: 'import_jobs_data_entity',
      foreignKey: {
          name: 'data_entityId',
      },
      constraints: false,
    });


    db.data_entities.hasMany(db.import_mappings, {
      as: 'import_mappings_data_entity',
      foreignKey: {
          name: 'data_entityId',
      },
      constraints: false,
    });



    db.data_entities.hasMany(db.validation_rule_sets, {
      as: 'validation_rule_sets_data_entity',
      foreignKey: {
          name: 'data_entityId',
      },
      constraints: false,
    });





    db.data_entities.hasMany(db.import_templates, {
      as: 'import_templates_data_entity',
      foreignKey: {
          name: 'data_entityId',
      },
      constraints: false,
    });








//end loop



    db.data_entities.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.data_entities.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.data_entities.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.data_entities.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return data_entities;
};


